\chapter{Hyperparameter Optimisation on GRID GPUs - Technical Setup}\label{chap:app:hp-opt}

% \subsection{Technical Setup}

To process all the data from the \acs{lhc}, including simulation, reconstruction etc., powerful computing resources are necessary. The \ac{wlcg} combines about 170 computing centres around the world to one powerful computing infrastructure with about 1 million computer cores and 1 exabyte of storage~\cite{wlcg}. 
The vast majority of these computing resources are CPUs. However, in the last couple of years, more and more shared GPU resources became available. Generally, not every institute which is doing \acs{ml} has GPUs available. Therefore a setup usable by the whole ATLAS collaboration is tested together with ATLAS IT, giving everyone access to GPU resources.\\
In general, the \ac{wlcg} software stack is not suitable for \acs{ml} since it is not flexible enough to cope for the quickly evolving and diverse \acs{ml} software. At this point, the Linux container images, often called \textit{Docker images}, come into play. They contain a full software stack packed in a container image and are fully isolated from the host environment. This allows the user to choose its custom software. Starting with freely accessible base-images, GitLab can automatically build such a custom image and the site administrators only have to provide the virtualisation software \textit{singularity}~\cite{10.1371/journal.pone.0177459} to allow the user to execute the container images. Typically, the base images are already optimised for GPU usage.\\
An example workflow is shown in Figure~\ref{fig:ftag:gridscheme}. The hyperparameter optimisation software~\cite{hpopt:guth} generates \textsc{json} configuration files containing the information about the hyperparameters of the network architecture. Each configuration file contains a different set of hyperparameters.
These configuration files, as well as the training and validation dataset, are uploaded to the \ac{wlcg} sites (via the rucio data management~\cite{DBLP:journals/corr/abs-1902-09857}). A container image built from Gitlab containing the training software is then deployed to various \ac{wlcg} sites running a large number of jobs over the different hyperparameters (config files). This procedure is illustrated in Figure~\ref{fig:ftag:grid-deploy}. Each job uses the same training and validation sample and a certain amount of hyperparameters are tested. The output is again \textsc{json} files containing the information about the performance of the \acs{nn} such as the training and validation loss and the background rejection at the $77\%$ \acs{wp}. This heavily parallelisable workload is running in a fraction of the time which would be necessary running them one after each other.\\
The final workflow for \acs{ml} developments would then for instance look as displayed in Figure~\ref{fig:ftag:hpworkflow}. The interactive development is done on the laptop accessing shared and centrally provided computing resources such as a \textit{JupyterHub}\footnote{At CERN this is available via \url{https://hub.cern.ch}.}. The code is pushed into a GitLab repository where a container image is automatically built and this can then be deployed to the \ac{wlcg}. In general, the hyperparameter scan can be also performed on any other computing cluster with a job scheduling system and singularity available.


\begin{figure}[htbp]
    \centering
    \includegraphics[width=.6\textwidth]{b-tagging/material_hpopt/HP-GRID-scheme.pdf}
    \caption{Schematic workflow deploying hyperparameter optimisations to the \ac{wlcg}.}
    \label{fig:ftag:gridscheme}
\end{figure}
\begin{figure}[htbp]
    \centering
    \includegraphics[width=.7\textwidth]{b-tagging/material_hpopt/HP-GRID-deploy.pdf}
    \caption{Job brokering illustration of the hyperparameter optimisation in GRID GPUs.}
    \label{fig:ftag:grid-deploy}
\end{figure}
\begin{figure}[htbp]
    \centering
    \includegraphics[width=.8\textwidth]{b-tagging/material_hpopt/workflow-NN.pdf}
    \caption{Workflow for machine learning model development.}
    \label{fig:ftag:hpworkflow}
\end{figure}